//
//  ViewController.swift
//  SwiftProduct
//
//  Created by home on 2017/11/22.
//  Copyright © 2017年 home. All rights reserved.
//

import UIKit

class ViewController: UIViewController,UICollectionViewDataSource,UICollectionViewDelegate {
    enum CollectionMode{
        case Normal
        case Long
    }
    let BJWidth = UIScreen.main.bounds.size.width
    let BJHeight = UIScreen.main.bounds.size.height
    var mode:CollectionMode = .Normal
    var flowLayout:UICollectionViewFlowLayout!
    
    @IBOutlet weak var myCollectionView: UICollectionView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        flowLayout = UICollectionViewFlowLayout.init()
        flowLayout.itemSize = CGSize(width:(BJWidth-30)/2 , height:(BJWidth-30)/2+50)
        myCollectionView.register(UINib(nibName:"NormalCell", bundle: nil), forCellWithReuseIdentifier:"Normal")
        myCollectionView.collectionViewLayout = flowLayout
        self.collectionViewMode(mode)
        // Do any additional setup after loading the view, typically from a nib.
    }
    
    @IBAction func changeLayout(_ sender: Any) {
        if (mode == .Normal){
            mode = .Long
        }
        else{
            mode = .Normal
        }
        self.collectionViewMode(mode)
    }
    
    //没办法 一进来就要调用所以不能跟点击事件合并成一个方法
    func collectionViewMode(_ mode: CollectionMode) {
        if (mode == .Normal){
            flowLayout.itemSize = CGSize(width:(BJWidth-30)/2 , height:(BJWidth-30)/2+50)
            myCollectionView.register(NormalCell.self, forCellWithReuseIdentifier:"Normal")
            myCollectionView.register(UINib(nibName:"NormalCell", bundle: nil), forCellWithReuseIdentifier:"Normal")
        }
        else{
            flowLayout.itemSize = CGSize(width:BJWidth-30 , height:(BJWidth-30)/2)
            myCollectionView.register(UINib(nibName:"LongCell", bundle: nil), forCellWithReuseIdentifier:"Long")
        }
        myCollectionView.reloadData()
    }
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return 40;
    }
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell:UICollectionViewCell
        if(mode == .Normal){
            cell = collectionView.dequeueReusableCell(withReuseIdentifier:"Normal", for:indexPath)
        }
        else{
            cell = collectionView.dequeueReusableCell(withReuseIdentifier:"Long", for:indexPath)
        }
        return cell
    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
}

